# WARNING
#
# THIS IS AN AUTOGENERATED FILE.
#
# MANUAL CHANGES CAN AND WILL BE OVERWRITTEN.

import re

from setuptools import setup

PACKAGE_NAME = 'personal_data'

PACKAGE_DESCRIPTION = """
# Personal Data Fetcher Systems.

This program collects several small data fetchers, for downloading personal
data spread around the internet. The fetchers are mostly related either to
personal finance, or to various nerdy hobbies.

Supported fetchers:

- Crunchyroll episode watch history
- FFXIV Lodestone achivement history
- Playstation achievements by way of PSN Profiles.
- Account balances for several backends supported by [`fin-depo`](https://gitfub.space/Jmaa/fin-depo)
  * Partisia Blockchain BYOC and MPC trackers
  * Kraken Account Balances
  * Kucoin Account Balances

## Usage

Add relevant secrets to
a [`secret_loader`](https://gitfub.space/Jmaa/secret_loader)-compatible
location, and run:

```sh
python -m personal_data
```

Use `--help` option to see all options.

## Further expansion

- [ ] YouTube (Music): Liked videos with title and URL.
- [ ] Steam Wishlist and Achievements
- [ ] [WaniKani](https://docs.api.wanikani.com)
- [ ] Ledger (Live?) Account Balances
""".strip()

PACKAGE_DESCRIPTION_SHORT = """
This program collects several small data fetchers, for downloading personal
data spread around the internet.""".strip()


def parse_version_file(text: str) -> str:
    match = re.match(r'^__version__\s*=\s*(["\'])([\d\.]+)\1$', text)
    if match is None:
        msg = 'Malformed _version.py file!'
        raise Exception(msg)
    return match.group(2)


with open(PACKAGE_NAME + '/_version.py') as f:
    version = parse_version_file(f.read())


REQUIREMENTS_MAIN = [
    'beautifulsoup4',
    'lxml',
    'requests',
    'requests_cache',
    'browsercookie',
    'cfscrape',
    'frozendict',
    'python-kucoin',
    'krakenex',
    'fin-depo @ git+https://gitfub.space/Jmaa/fin-depo.git',
    'secret_loader @ https://gitfub.space/Jmaa/secret_loader',
]
REQUIREMENTS_TEST = [
    'pytest',
]


setup(
    name=PACKAGE_NAME,
    version=version,
    description=PACKAGE_DESCRIPTION_SHORT,
    long_description=PACKAGE_DESCRIPTION,
    long_description_content_type='text/markdown',
    author='Jon Michael Aanes',
    author_email='jonjmaa@gmail.com',
    url='https://gitfub.space/Jmaa/' + PACKAGE_NAME,
    packages=[PACKAGE_NAME],
    install_requires=REQUIREMENTS_MAIN,
    extras_require={
        'test': REQUIREMENTS_TEST,
    },
    python_requires='>=3.9',
)
